// ChatBrokerObj.cpp : Implementation of CChatBrokerObj
#include "stdafx.h"
#include "ChatBroker.h"
#include "ChatBrokerObj.h"

/////////////////////////////////////////////////////////////////////////////
// CChatBrokerObj

STDMETHODIMP CChatBrokerObj::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IRegisterChatServer,
		&IID_IDiscussions
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CChatBrokerObj::Register(IUnknown *pChatServer, wchar_t *pwszDiscussion)
{
   HRESULT hr = S_OK;
   if (!_Module.m_list.AddDiscussion(pwszDiscussion, pChatServer)) {
      hr = AtlReportError(CLSID_ChatBrokerObj, 
         TEXT("[Duplicate Discussion] Broker refused to register Chat Server."),
         IID_IRegisterChatServer, 
         MAKE_HRESULT(SEVERITY_ERROR, FACILITY_ITF, 0x201));
   }
   return hr;
}

STDMETHODIMP CChatBrokerObj::Unregister(wchar_t *pwszDiscussion)
{
   _Module.m_list.RemoveDiscussion(pwszDiscussion);
   return S_OK;
}


STDMETHODIMP CChatBrokerObj::GetDiscussionList(wchar_t **ppwszDiscussionList)
{
   *ppwszDiscussionList = _Module.m_list.GetDiscussionList();
	return S_OK;
}


STDMETHODIMP CChatBrokerObj::GetChatServer(wchar_t *pwszDiscussion, IUnknown **ppUnk)
{
   *ppUnk = _Module.m_list.GetChatServer(pwszDiscussion);
   if (*ppUnk==NULL) {
      return AtlReportError(CLSID_ChatBrokerObj, 
         TEXT("[Invalid Discussion] Where did you say to get this discussion?"),
         IID_IDiscussions, 
         MAKE_HRESULT(SEVERITY_ERROR, FACILITY_ITF, 0x202));
   }

	return S_OK;
}
