// ChatBrokerObj.h : Declaration of the CChatBrokerObj

#ifndef __CHATBROKEROBJ_H_
#define __CHATBROKEROBJ_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CChatBrokerObj
class ATL_NO_VTABLE CChatBrokerObj : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CChatBrokerObj, &CLSID_ChatBrokerObj>,
	public ISupportErrorInfo,
	public IRegisterChatServer,
	public IDiscussions  // Add this manually
{
public:
	DECLARE_CLASSFACTORY_SINGLETON(CChatBrokerObj)
	CChatBrokerObj()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CHATBROKEROBJ)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CChatBrokerObj)
	COM_INTERFACE_ENTRY(IRegisterChatServer)
	COM_INTERFACE_ENTRY(IDiscussions)  // add this manually
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IRegisterChatServer
public:
	STDMETHOD(Unregister)(/*[in, string]*/ wchar_t *pwszDiscussion);
	STDMETHOD(Register)(/*[in]*/ IUnknown *pChatServer, /*[in, string]*/ wchar_t *pwszDiscussion);

// IDiscussions  --  Add these manually
public:
    STDMETHOD(GetDiscussionList)(/*[out, string]*/ wchar_t **ppwszDiscussionList);
    STDMETHOD(GetChatServer)(/*[in, string]*/ wchar_t *pwszDiscussion, /*[out]*/ IUnknown **ppUnk);
};

#endif //__CHATBROKEROBJ_H_
