// ChatClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ChatClient.h"
#include "ChatClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatClientDlg dialog

CChatClientDlg::CChatClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChatClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChatClientDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CChatClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChatClientDlg)
	DDX_Control(pDX, IDC_BUTTON_SEND, m_Send);
	DDX_Control(pDX, IDC_BUTTON_EXIT, m_Exit);
	DDX_Control(pDX, IDC_BUTTON_JOIN, m_Join);
	DDX_Control(pDX, IDC_BUTTON_CONNECT, m_Connect);
	DDX_Control(pDX, IDC_EDIT_MESSAGE, m_Message);
	DDX_Control(pDX, IDC_LIST_CONVERSATION, m_Conversation);
	DDX_Control(pDX, IDC_COMBO_DISCUSSION, m_Discussion);
	DDX_Control(pDX, IDC_EDIT_ALIAS, m_Alias);
	DDX_Control(pDX, IDC_EDIT_BROKER, m_Broker);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChatClientDlg, CDialog)
	//{{AFX_MSG_MAP(CChatClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnButtonConnect)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, OnButtonExit)
	ON_BN_CLICKED(IDC_BUTTON_JOIN, OnButtonJoin)
	ON_BN_CLICKED(IDC_BUTTON_SEND, OnButtonSend)
	ON_EN_CHANGE(IDC_EDIT_BROKER, OnChangeEditBroker)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatClientDlg message handlers

BOOL CChatClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

   // OUR CODE...Begin
   m_Conversation.SetHorizontalExtent(1000);
   m_Send.EnableWindow(FALSE);
   m_Join.EnableWindow(FALSE);
   m_Connect.EnableWindow(FALSE);   

   // default broker destination is local computer
   char szComputerName[MAX_COMPUTERNAME_LENGTH+1];
   DWORD dwSize = MAX_COMPUTERNAME_LENGTH+1;
   ::GetComputerName(szComputerName, &dwSize);
   m_Broker.SetWindowText(szComputerName);

   // default user
   TCHAR szName[MAX_PATH]; dwSize = MAX_PATH;
   ::GetUserName(szName, &dwSize);  
   m_Alias.SetWindowText(szName);

   m_pBroker = NULL;
   m_pSendMessage = NULL;
   // OUR CODE...End

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CChatClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChatClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChatClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//-------------------------------------------------------------
//-------------------------------------------------------------
//-------------------------------------------------------------
//  copy the CLSID needed into this file....
//-------------------------------------------------------------
//-------------------------------------------------------------
//-------------------------------------------------------------
const CLSID CLSID_ChatBrokerObj = {0x3284B5FF,0x6893,0x11D2,{0x87,0xCE,0x00,0x60,0x08,0xCD,0xD9,0xAE}};
const CLSID CLSID_ChatServerObj = {0x3284B60D,0x6893,0x11D2,{0x87,0xCE,0x00,0x60,0x08,0xCD,0xD9,0xAE}};

#include <comdef.h>
#include <atlbase.h>

//***********************************************************
// The following code shows you how to implement the sink
// object using pure C++
//***********************************************************
class CoMsgSink : public IReceiveMessage {
public:
   CoMsgSink() : m_pConversation(NULL) {}
   STDMETHODIMP QueryInterface(REFIID riid, void **ppv)
   {
      if (ppv==NULL) { return E_INVALIDARG; }
      if (riid==IID_IUnknown || riid==IID_IReceiveMessage) {
         *ppv= static_cast<IReceiveMessage*>(this);
      } else {
         *ppv=NULL; return E_NOINTERFACE ;
      }

      reinterpret_cast<IUnknown *>(*ppv)->AddRef();
      return S_OK;
   }

   STDMETHODIMP_(ULONG) AddRef(void)
   { return 1; }

   STDMETHODIMP_(ULONG) Release(void)
   { return 1; }

   // IReceiveMessage Methods
   STDMETHODIMP OnReply(wchar_t *pwszReply)
   {
      if (m_pConversation) {
         m_pConversation->InsertString(-1, (char*)_bstr_t(pwszReply));
         int iCount = m_pConversation->GetCount();
         m_pConversation->SetCaretIndex(iCount);
         if (iCount>20) m_pConversation->DeleteString(0);
      }
      return S_OK;
   }

	CListBox	*m_pConversation;
} g_MsgSink;



inline void Chk(HRESULT hr) 
{
   if (FAILED(hr)) _com_issue_error(hr);
}

DWORD RegisterInterfaceMarshaler(REFIID riid)
{
    DWORD dwCookie=0;
    try {
        IUnknown *pUnk=0;
        HRESULT hr = ::DllGetClassObject(riid, IID_IUnknown, (void**)&pUnk);
        if (FAILED(hr)) throw _com_error(hr);
        hr = ::CoRegisterClassObject(riid, pUnk, 
                CLSCTX_INPROC_SERVER,
                REGCLS_MULTIPLEUSE, &dwCookie);
        if (FAILED(hr)) throw _com_error(hr);
        hr = ::CoRegisterPSClsid(riid, riid);
        if (FAILED(hr)) throw _com_error(hr);
    } catch (_com_error & er) {
        ::MessageBox(0, er.ErrorMessage(), 0, MB_OK);
    }

    return dwCookie;
}

void UnregisterInterfaceMarshaler(DWORD dwCookie)
{
    HRESULT hr = ::CoRevokeClassObject(dwCookie);
}



void CChatClientDlg::OnButtonConnect() 
{
   // Cookies for interface marshaler registration
   static DWORD dwBroker, dwServer, dwClient;

   CString strButtonLabel;
	m_Connect.GetWindowText(strButtonLabel);
   if (strButtonLabel==CString("Connect")) {
      // Initialize COM
      CoInitialize(0);

      // Register interface marshalers
      dwBroker = RegisterInterfaceMarshaler(IID_IDiscussions);
      dwServer = RegisterInterfaceMarshaler(IID_ISendMessage);
      dwClient = RegisterInterfaceMarshaler(IID_IReceiveMessage);

      // Update GUI
   	m_Connect.SetWindowText("Disconnect");
      m_Exit.EnableWindow(FALSE); 
      m_Join.EnableWindow(TRUE); 
      m_Broker.EnableWindow(FALSE);
      m_Alias.EnableWindow(FALSE);
      
      CString strBroker; m_Broker.GetWindowText(strBroker);
      _bstr_t bstrBroker(strBroker);
      COSERVERINFO csi = { 0, bstrBroker, NULL, 0 }; 
      MULTI_QI mqi[] = { {&IID_IDiscussions, NULL, S_OK} };
      try {
         // Activate the singleton broker.
         HRESULT hr = CoCreateInstanceEx(CLSID_ChatBrokerObj, NULL, 
            CLSCTX_SERVER, &csi, sizeof(mqi)/sizeof(mqi[0]), mqi); 
         Chk(hr); Chk(mqi[0].hr);
         m_pBroker = reinterpret_cast<IDiscussions*>(mqi[0].pItf);

         // Get the discussion list from the broker.
         wchar_t *pList;
         m_pBroker->GetDiscussionList(&pList);         
         CString strList = (char*)_bstr_t(pList);
         if (pList) CoTaskMemFree(pList);

         // Got the list
         m_Discussion.ResetContent();
         if (strList.IsEmpty()) {
            // The broker reports no available Chat Servers.
            m_Join.EnableWindow(FALSE);
            MessageBox("No Chat Servers available");
         } else {
            // Add discussions into the m_Discussion listbox.
            while (!strList.IsEmpty()) {
               int i = strList.Find('\n');
               if (i==-1) {
                  m_Discussion.AddString(strList);
                  break;
               }
               CString strDiscuss = strList.Left(i);
               m_Discussion.AddString(strDiscuss);
               strList = strList.Mid(i+1, strList.GetLength());
            }
            m_Discussion.SetCurSel(0);
         }
      } catch (_com_error & error) {
         MessageBox(error.ErrorMessage());
         return ;
      }
   } else {
      // Let go of the broker.
      if (m_pBroker) m_pBroker->Release();
      m_pBroker = NULL ;

      // Unregister interface marshalers
      UnregisterInterfaceMarshaler(dwBroker);
      UnregisterInterfaceMarshaler(dwServer);
      UnregisterInterfaceMarshaler(dwClient);

      // Done using COM
      CoUninitialize();

      // Update GUI 
   	m_Connect.SetWindowText("Connect");
      m_Exit.EnableWindow(TRUE); 
      m_Join.EnableWindow(FALSE); 
      m_Broker.EnableWindow(TRUE);
      m_Alias.EnableWindow(TRUE);
   }
}

void CChatClientDlg::OnButtonExit() 
{
   // clean up
   EndDialog(IDOK);
}

void CChatClientDlg::OnButtonJoin() 
{
   CString strButtonLabel;
	m_Join.GetWindowText(strButtonLabel);
   if (strButtonLabel==CString("Join")) {
   	m_Join.SetWindowText("Leave");
      m_Connect.EnableWindow(FALSE); 
      m_Send.EnableWindow(TRUE);
      m_Discussion.EnableWindow(FALSE);
      CString strServer;
      m_Discussion.GetLBText(m_Discussion.GetCurSel(), strServer);

      try {
         // Getting the IUnknown to the Chat Server
         IUnknown *pUnk=0;
         HRESULT hr = m_pBroker->GetChatServer(_bstr_t(strServer), &pUnk);
         Chk(hr);
         hr = pUnk->QueryInterface(IID_ISendMessage, (void**)&m_pSendMessage);
         Chk(hr);
         ASSERT(m_pSendMessage);

         CComPtr<IConnectionPointContainer> pConn;
         hr = m_pSendMessage->QueryInterface(IID_IConnectionPointContainer, (void**)&pConn);
         Chk(hr);
         CComPtr<IConnectionPoint> pConnPoint;
         hr = pConn->FindConnectionPoint(IID_IReceiveMessage, (IConnectionPoint**)&pConnPoint);
         Chk(hr);
         g_MsgSink.m_pConversation = &m_Conversation;
         hr = pConnPoint->Advise(&g_MsgSink, &m_dwCookie);
         Chk(hr);

         CString strAlias; m_Alias.GetWindowText(strAlias);
         CString strMessage; 
         strMessage.Format("***%s has just joined***", strAlias);
         hr = m_pSendMessage->Talk(_bstr_t(strMessage));
         Chk(hr);
      } catch (_com_error & error) {
         m_pSendMessage = NULL;
         MessageBox(error.ErrorMessage());
      }
   } else {
      if (m_pSendMessage) {
         try {
            CString strAlias; m_Alias.GetWindowText(strAlias);
            CString strMessage; 
            strMessage.Format("***%s has left the discussion***", strAlias);
            HRESULT hr = m_pSendMessage->Talk(_bstr_t(strMessage));
            Chk(hr);

            CComPtr<IConnectionPointContainer> pConn;
            hr = m_pSendMessage->QueryInterface(IID_IConnectionPointContainer, (void**)&pConn);
            Chk(hr);
            CComPtr<IConnectionPoint> pConnPoint;
            hr = pConn->FindConnectionPoint(IID_IReceiveMessage, (IConnectionPoint**)&pConnPoint);
            Chk(hr);
            hr = pConnPoint->Unadvise(m_dwCookie);
            Chk(hr);
            m_pSendMessage->Release();
            m_pSendMessage = NULL ;
         } catch (_com_error & error) {
            MessageBox(error.ErrorMessage());
         }
      }

   	m_Join.SetWindowText("Join");
      m_Connect.EnableWindow(TRUE); 
      m_Send.EnableWindow(FALSE);
      m_Discussion.EnableWindow(TRUE);
   }
}

void CChatClientDlg::OnButtonSend() 
{
   ASSERT(m_pSendMessage);
   CString strAlias; m_Alias.GetWindowText(strAlias);
   CString strMsg; m_Message.GetWindowText(strMsg);
   CString strMessage; 
   strMessage.Format("%s :  %s", strAlias, strMsg);

   try {
      HRESULT hr = m_pSendMessage->Talk(_bstr_t(strMessage));
      Chk(hr);
   } catch (_com_error & error) {
      MessageBox(error.ErrorMessage());
   }   
   m_Message.SetWindowText("");
}

void CChatClientDlg::OnChangeEditBroker() 
{
   CString strBroker;
	m_Broker.GetWindowText(strBroker);
   (strBroker.GetLength()>0) 
      ? m_Connect.EnableWindow(TRUE) 
      : m_Connect.EnableWindow(FALSE);
}


void CChatClientDlg::OnCancel()
{ // prevent closing with ESC key
}
