// ATLCyberOcr.cpp : Implementation of CATLCyberOcr

#include "stdafx.h"
#include "ATLCyberServer.h"
#include "ATLCyberOcr.h"

/////////////////////////////////////////////////////////////////////////////
// CATLCyberOcr


STDMETHODIMP CATLCyberOcr::get_OCRServerName(BSTR *pVal)
{
   *pVal = m_OCRServerName.Copy(); 
	return S_OK;
}

STDMETHODIMP CATLCyberOcr::put_OCRServerName(BSTR newVal)
{
   if (m_OCRServerName==newVal) return S_OK;
   m_pRemoteOcr.Disconnect();
   m_OCRServerName = newVal;

   try {
      m_pRemoteOcr.Connect(m_OCRServerName);
   } catch (_com_error & error) {
      MessageBox(error.ErrorMessage());
   }

   return S_OK;
}

const CLSID CLSID_OcrProcessor = 
   {0x926AC9C4,0x6C4A,0x11D2,{0x87,0xD1,0x00,0x60,0x08,0xCD,0xD9,0xAE}};

STDMETHODIMP CATLCyberOcr::OcrImage(BSTR Image, BSTR *pText)
{
   try {
      CComVariant vtImage; CComBSTR pOcrText;
      HRESULT hr = m_pRemoteOcr->OcrWholeImage(vtImage, &pOcrText);
      if (FAILED(hr)) throw _com_error(hr);
      *pText = pOcrText ;
      m_ctlStatic.SetWindowText(TEXT("Successfully processed..."));
   } catch (_com_error & error) {
      m_ctlStatic.SetWindowText(error.ErrorMessage());
   }
   return S_OK;
}
