// OcrProcessor.cpp : Implementation of COcrProcessor
#include "stdafx.h"
#include "OCRServer.h"
#include "OcrProcessor.h"

/////////////////////////////////////////////////////////////////////////////
// COcrProcessor


#pragma warning(disable:4786)  // Disable long name warnings
#include <string>
using namespace std;




char g_szFakeOcrText[10*MAX_PATH] = { 
	"COVERAGES AND LIMITS UNDER YOUR LIBERTYGUARD HOMEOWNERS POLICY\r\n"
    "YOUR DWELLING WITH REPLACEMENT COST\t\t$361,000\r\n"
    "OTHER STRUCTURES ON RESIDENCE PREMISES\t$36,100\r\n"
    "PERSONAL PROPERTY WITH REPLACEMENT COST\t$270,750\r\n"
    "LOSS OF USE OF YOUR RESIDENCE PREMISES\t$108,300\r\n"
    "PERSONAL LIABILITY (EACH OCCURRENCE)\t\t$300,000\r\n"
    "MEDICAL PAYMENTS TO OTHERS (EACH PERSON)\t$1,000\r\n"
    "\r\n"
    "||||||||||||||||||||||||||||||||||||||||||\r\n"
};


string ProcessImage(unsigned char * pszMemTiff, unsigned long lMemTiffLen)
{
	string strResult = g_szFakeOcrText;

	// Since you don't have and OPS Engine, this function is stubbed.
	// But basically, this function opens a connection to the OPS Engine
	// via TCP/IP and asks the OPS to OCR the TIFF image.

	return  strResult ;
}



STDMETHODIMP COcrProcessor::OcrWholeImage(VARIANT binaryImageArray, BSTR *pOcrText)
{
   CComBSTR bstrOcrText;
   // Make sure that the variant contains a SAFEARRAY of bytes
   if (binaryImageArray.vt == (VT_ARRAY|VT_UI1)) {
      SAFEARRAY *pArray = binaryImageArray.parray ;
      unsigned char *pRawData;
      HRESULT hr = SafeArrayAccessData(pArray, (void HUGEP**)&pRawData);
      unsigned long arraySize = pArray->rgsabound[0].cElements ;
      // Pull out the image buffer from the SAFEARRAY
      unsigned char *pImageData = new unsigned char[arraySize] ;
      memcpy(pImageData, pRawData, arraySize);
      SafeArrayUnaccessData(pArray); 
      // Perform OCR Processing
      string strOcrText = ProcessImage(pImageData, arraySize);
      bstrOcrText.Append(strOcrText.data()) ;
      delete [] pImageData ;
   } else {
      // Invalid SAFEARRAY type. Return dummy text and an error message.
      // Assume that g_szFakeOcrText is global holding dummy text.
      bstrOcrText.Append(g_szFakeOcrText) ;
      bstrOcrText.Append("***Received VARIANT is not valid***") ;
   }

   *pOcrText = bstrOcrText.Copy();

   return S_OK;
}


STDMETHODIMP 
COcrProcessor::Check(wchar_t * pwszWord, struct PossibleWords *pWords)
{
  wcscpy(reinterpret_cast<wchar_t *>(pWords->wszOne), OLESTR("ChoiceOne"));
  wcscpy(reinterpret_cast<wchar_t *>(pWords->wszTwo), OLESTR("ChoiceTwo"));

  return S_OK;
}
